// TableMakerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TableMaker.h"
#include "TableMakerDlg.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define PI2 ( 8.0 * atan(1.0) )
#define MAX_HELP_SIZE 512
#define HELP0_START 0x0C00
#define HELP1_START 0x0E00

#define IMAGE_LINES 256
#define IMAGE_PIX_PER_LINE 320
#define IMAGE_COLORS 3
#define IMAGE_BYTES (IMAGE_LINES*IMAGE_PIX_PER_LINE*IMAGE_COLORS)

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTableMakerDlg dialog

CTableMakerDlg::CTableMakerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTableMakerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTableMakerDlg)
	m_DestPathStr = _T("");
	m_TableSelected = -1;
	m_HelpTextString = _T("");
	m_HelpEditSelect = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pBuf = NULL;
}

void CTableMakerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTableMakerDlg)
	DDX_Control(pDX, IDC_HELPEDIT, m_HelpEditCtrl);
	DDX_Text(pDX, IDC_FILETXT, m_DestPathStr);
	DDX_Radio(pDX, IDC_TABLE0, m_TableSelected);
	DDX_Text(pDX, IDC_HELPEDIT, m_HelpTextString);
	DDX_Radio(pDX, IDC_HELPRADIO0, m_HelpEditSelect);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTableMakerDlg, CDialog)
	//{{AFX_MSG_MAP(CTableMakerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_GENBUTTON, OnGenbutton)
	ON_BN_CLICKED(IDC_SELFILEBUTTON, OnSelfilebutton)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_HELPRADIO0, OnHelpradio0)
	ON_BN_CLICKED(IDC_HELPRADIO1, OnHelpradio1)
	ON_BN_CLICKED(IDC_SELFILEBUTTON2, OnSelfilebutton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTableMakerDlg message handlers

BOOL CTableMakerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	ReadRegistrySettings();
	m_DestPathStr = m_DestFilePath;
	m_HelpEditCtrl.SetLimitText(MAX_HELP_SIZE-1);
	if(m_HelpEditSelect==0)
		m_HelpTextString = m_Help0Text;
	else
		m_HelpTextString = m_Help1Text;
	UpdateData(FALSE);
	for(int i=0; i<1024; i++)
		m_Buf[i] = 0xFFFFFFFF;
	m_pBuf = NULL;
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTableMakerDlg::OnClose() 
{
	UpdateData(TRUE);
	WriteRegistrySettings();	
	CDialog::OnClose();
}

BOOL CTableMakerDlg::WriteRegistrySettings()
{
CWinApp* pApp = AfxGetApp();
	UpdateData(TRUE);
//save INT's
	m_Str.Format("%i", m_TableSelected );
	if(!pApp->WriteProfileString("Settings\\Ints", "m_TableSelected", m_Str) )
		return FALSE;
	m_Str.Format("%i", m_HelpEditSelect );
	if(!pApp->WriteProfileString("Settings\\Ints", "m_HelpEditSelect", m_Str) )
		return FALSE;
	
//save strings
	if(m_HelpEditSelect==0)
		m_Help0Text =m_HelpTextString;
	else
		m_Help1Text =m_HelpTextString;
	if(!pApp->WriteProfileString("Settings\\Strings", "m_Help0Text", m_Help0Text))
		return FALSE;
	if(!pApp->WriteProfileString("Settings\\Strings", "m_Help1Text", m_Help1Text))
		return FALSE;
	if(!pApp->WriteProfileString("Settings\\Strings", "m_DestFilePath", m_DestFilePath))
		return FALSE;
	if(!pApp->WriteProfileString("Settings\\Strings", "m_BMPFilePath", m_BMPFilePath))
		return FALSE;
	
	return TRUE;
}

BOOL CTableMakerDlg::ReadRegistrySettings()
{
CWinApp* pApp = AfxGetApp();
INT cRead;

//Get INT's
	m_Str = pApp->GetProfileString ("Settings\\Ints", "m_TableSelected");
	cRead = _stscanf (m_Str, "%i", &m_TableSelected );
	if(cRead != 1)
		m_TableSelected = 0;
	m_Str = pApp->GetProfileString ("Settings\\Ints", "m_HelpEditSelect");
	cRead = _stscanf (m_Str, "%i", &m_HelpEditSelect );
	if(cRead != 1)
		m_HelpEditSelect = 0;

//get strings
	m_Help0Text = pApp->GetProfileString("Settings\\Strings", "m_Help0Text",_T("Enter Help 0 Text Here"));
	m_Help1Text = pApp->GetProfileString("Settings\\Strings", "m_Help1Text",_T("Enter Help 1 Text Here"));
	m_DestFilePath = pApp->GetProfileString("Settings\\Strings", "m_DestFilePath",_T("c:\\default.bin"));
	m_BMPFilePath = pApp->GetProfileString("Settings\\Strings", "m_BMPFilePath",_T("c:\\default.bmp"));
	return TRUE;
}

void CTableMakerDlg::OnHelpradio0() 
{
	if(m_HelpEditSelect==1)
	{
		UpdateData(TRUE);
		m_Help1Text =m_HelpTextString;
	}
	else
		UpdateData(TRUE);
	m_HelpEditCtrl.SetSel( 0xFFFF0000);
	m_HelpEditCtrl.Clear();
	m_HelpTextString = m_Help0Text;
	UpdateData(FALSE);
}

void CTableMakerDlg::OnHelpradio1() 
{
	if(m_HelpEditSelect==0)
	{
		UpdateData(TRUE);
		m_Help0Text =m_HelpTextString;
	}
	else
		UpdateData(TRUE);
	m_HelpEditCtrl.SetSel( 0xFFFF0000);
	m_HelpEditCtrl.Clear();
	m_HelpTextString = m_Help1Text;
	UpdateData(FALSE);
	
}

void CTableMakerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTableMakerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTableMakerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTableMakerDlg::OnGenbutton() 
{
CFile cfile;
	UpdateData(TRUE);
	if(m_HelpEditSelect==0)
		m_Help0Text = m_HelpTextString;
	else
		m_Help1Text = m_HelpTextString;
	if(m_TableSelected==0)
		MakeTable0();
	else
		if(m_TableSelected==1)
			MakeTable1();
		else
			MakeBMPTable();

	BOOL ret = cfile.Open(m_DestFilePath,CFile::modeCreate|CFile::modeWrite);
	if(ret)
	{
		if(m_TableSelected==2)
			cfile.Write(m_pBuf,IMAGE_BYTES);
		else
			cfile.Write(m_Buf,1024*4);
	}
	if(m_pBuf)
	{
		delete m_pBuf;
		m_pBuf = NULL;
	}
}

void CTableMakerDlg::OnSelfilebutton() 
{
CString sFilter = "Table Files (*.bin)|*.bin||";
CString str;
CFileDialog DlgOutfile( FALSE, _T("bin"), m_DestFilePath, 
			OFN_LONGNAMES|OFN_NOCHANGEDIR|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
			(LPCTSTR)sFilter, this );
	UpdateData(TRUE);
	if( DlgOutfile.DoModal() == IDOK)
	{
		m_DestFilePath = DlgOutfile.GetPathName();
		m_DestPathStr = m_DestFilePath;
	}	
	UpdateData(FALSE);
}

void CTableMakerDlg::OnSelfilebutton2()		//bmp file read
{
CString sFilter = "BMP Files (*.bmp)|*.bmp||";
CString str;
CFileDialog DlgInfile( TRUE, _T("bmp"), m_BMPFilePath, 
			OFN_LONGNAMES|OFN_NOCHANGEDIR|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
			(LPCTSTR)sFilter, this );
	UpdateData(TRUE);
	if( DlgInfile.DoModal() == IDOK)
	{
		m_BMPFilePath = DlgInfile.GetPathName();
	}	
	UpdateData(FALSE);
}

void CTableMakerDlg::MakeTable0()
{	
	//Create one cycle sine wave with amplitude of 5000Hz
	//for FM CW waveform.
int i;
double T = PI2/947.0;		//period of table
double val;
double scale = 5000.0;
	for( i=0; i<947; i++)
	{
		val = scale * (sin( (double)i * T/1.0));
		m_Buf[i] = (__int32)val;
	}
}

void CTableMakerDlg::MakeTable1()
{
int i;
double T = PI2/64.0;
double val;
__int16* pbuf = (__int16*)m_Buf;
	//Create 64 sample Cos table for PSK31 amplitude shape
	double scale = 16383.0;	//maximum 14 bit amplitude swing
	for( i=0; i<64; i++)
	{
		val = scale * (cos( (double)i * T/2.0));
		val = fabs(val);
		pbuf[i] = (__int16)val;
	}
	//load help text strings at end of table
char* pbuf2 = (char*)m_Buf;
int length = m_Help0Text.GetLength();
char ch;
	i = 0;
	if(length>0)
	{
		do{
			ch = m_Help0Text.GetAt(i);
			pbuf2[HELP0_START + i] = ch;
			i++;
		}while( i<MAX_HELP_SIZE && i<length); 
		pbuf2[HELP0_START + i] = 0;
	}
	length = m_Help1Text.GetLength();
	i = 0;
	if(length>0)
	{
		do{
			ch = m_Help1Text.GetAt(i);
			pbuf2[HELP1_START + i] = ch;
			i++;
		}while( i<MAX_HELP_SIZE && i<length); 
		pbuf2[HELP1_START + i] = 0;
	}
}

void CTableMakerDlg::MakeBMPTable()
{	
FILE *strmin;
	if(m_pBuf)
		delete m_pBuf;
	m_pBuf = new unsigned char[IMAGE_BYTES];
	for(int i=0; i<IMAGE_BYTES; i++)
		m_pBuf[i] = 0x55;

	if( (strmin = fopen( m_BMPFilePath, _T("rb") )) != NULL )
	{
		fseek( strmin, 0, SEEK_SET );
		fread( &m_BMPfile, sizeof(m_BMPfile),1, strmin );
		fseek( strmin, 14, SEEK_SET );
		fread( &m_BMPinfo, sizeof(m_BMPinfo), 1, strmin );
		if( (m_BMPinfo.biWidth != 320) ||(m_BMPinfo.biHeight != 256) ||
			(m_BMPinfo.biCompression != 0) )
		{
			fclose(strmin);
			return;
		}
		fseek( strmin, m_BMPfile.bfOffBits, SEEK_SET );
		int curInLine;
		int curpixel;
		int curOutLine = IMAGE_LINES-1;
		unsigned char pix;
		for(curInLine=0; curInLine<IMAGE_LINES; curInLine++)
		{
			for(curpixel=0; curpixel<IMAGE_PIX_PER_LINE; curpixel++)
			{
				int adr = curOutLine*IMAGE_COLORS*IMAGE_PIX_PER_LINE + curpixel;
				pix = fgetc(strmin);	//get Blue pixel
				m_pBuf[adr + 1*IMAGE_PIX_PER_LINE] = pix;

				pix = fgetc(strmin);	//get Green pixel
				m_pBuf[adr + 0*IMAGE_PIX_PER_LINE] = pix;

				pix = fgetc(strmin);	//get Red pixel
				m_pBuf[adr + 2*IMAGE_PIX_PER_LINE] = pix;
				if( feof(strmin) )
				{
					AfxMessageBox("End of file");
					return;
				}
			}
			curOutLine--;
		}
		fclose(strmin);
	}	
}
